/* =========================================================================

InDesign ExtendScript

NAME: InChange.js [old name UpCS.js]
VERSION: 1.0

AUTHOR: Vitaly Batushev
DATE  : 5.04.2005

DESCRIPTION:
       
 ,    ,     
 .    
   :     
    ,     ,
      .   
   .

 ,  ,    InChange.ini.
   ,      .

       .

   JPEG  TIFF     : JPG/JPEG  TIF/TIFF ,
    "Inform me about lost files" ("   ")
          .

           Windows:
InChange.ru.slang.        
  (InChange.ru.slang)  .

          ArrayTypesOfImages.

        (obutrin@indesign.rudtp.ru)

SPECIAL THANKS:   ;)

SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */

var ScriptName = app.activeScript.name.substr(0, app.activeScript.name.length - 3);
var ScriptVersion = "1.0";
var ArrayTypesOfImages = new Array('AI', 'EMF', 'EPS', 'GIF', 'JPEG', 'PDF', 'PDP',
								   'PNG', 'TIFF', 'WMF');

//=== Language Default ====================================================	
		var strFiles = 'files';	
		var strSelectFld = 'Select Folder';
		var NoOpenDocuments = 'No open documents!';
		var ScriptHead = ScriptName + ': Change images in publication';
		var TypeSearchObjects = 'Search:';
		var FolderOfSource = 'Folder with source files:';
		var TypeReplacedObjects = 'Change with:';
		var InfoAboutLost = 'Inform me about lost files';
		var strRB = 'Fit images';
		var FitNoFit = 'No Fit';
		var FitContentToFrame = 'Content to frame';
		var FitFrameToContent = 'Frame to content';
		var FitProportionally = 'Proportionally';
		var FitCenterContent = 'Center content';
		var strFile = 'File';
		var strNoPresent = 'no present!';
//=== End Language Default ====================================================	

	var myIniFile = new File (app.activeScript.path + "/" + ScriptName + ".ini");
	if (!myIniFile.exists) {
		crtini = CreateINI(ScriptName, ScriptVersion);
		eval ("//@include \'" + ScriptName + ".ini\';");
	} else {
		eval ("//@include \'" + ScriptName + ".ini\';");
	}
	var myLangFile = new File (app.activeScript.path + "/" + iniLangFile);
	if (!myLangFile.exists) {
	} else {
		eval ("//@include \'" + iniLangFile + "\';");
	}
if (ScriptVersion != iniScriptVersion) {
	SaveINI(ScriptName, ScriptVersion);
}

with (app) {
	
if (documents.length < 1) {
	alert(NoOpenDocuments);
	exit();
}
	var myDoc = activeDocument;
	var ImageTypes = new Array;
	for (it = 0; it < ArrayTypesOfImages.length; it++)
	{
		ImageTypes.push(ArrayTypesOfImages[it] + ' ' + strFiles);
	}
	
	var myDlg = dialogs.add({name: ScriptHead});
	with (myDlg) {
		with (dialogColumns.add())	{
			with (borderPanels.add()) {
				var lblSearch = staticTexts.add({staticLabel:TypeSearchObjects});
				var dropSearch = dropdowns.add({stringList: ImageTypes, selectedIndex: TOS, minWidth: 136});
				var lblReplace = staticTexts.add({staticLabel:TypeReplacedObjects});
				var dropReplace = dropdowns.add({stringList: ImageTypes, selectedIndex: TOR, minWidth: 117});
			}
			with (dialogRows.add())	{
					var lblWDir = staticTexts.add({staticLabel:FolderOfSource + " " + wDir});
			}
			with (dialogRows.add())	{		
				with (borderPanels.add()) {
				var lblRB = staticTexts.add({staticLabel:strRB + "     "});
					with (radiobuttonGroups.add()) {
						var rb0 = radiobuttonControls.add({staticLabel:FitNoFit});
						var rb1 = radiobuttonControls.add({staticLabel:FitContentToFrame});
						var rb2 = radiobuttonControls.add({staticLabel:FitFrameToContent});
						var rb3 = radiobuttonControls.add({staticLabel:FitProportionally});
						var rb4 = radiobuttonControls.add({staticLabel:FitCenterContent});
						switch (ValueFit) 
						{
		   					case 0:
		   						rb0.checkedState = true;
		   						break;
		   					case 1:
		   						rb1.checkedState = true;
		   						break;
		   					case 2:
		   						rb2.checkedState = true;
		   						break;
		   					case 3:
		   						rb3.checkedState = true;
		   						break;
		   					case 4:
		   						rb4.checkedState = true;
		   						break;
		   				}

					}
				}
			with (dialogRows.add())	{
					var chkAlert = checkboxControls.add({staticLabel:InfoAboutLost, checkedState: InfoLost});
					var EmptyLine = staticTexts.add({staticLabel:""});
				}
 			}
			with (dialogRows.add())	{		
				var lblCredits = staticTexts.add({staticLabel:"Vitaly Batushev - 2005 [http://indesign.rudtp.ru]"}); 				
 			}
		}
	}
	var result = myDlg.show();
	if ( result == false ) { exit(); }
	
	var mySType = new Array(ArrayTypesOfImages[dropSearch.selectedIndex]);
	if (mySType[0] == 'JPEG') {
		mySType = mySType.push('JPG');
	}
	if (mySType[0] == 'TIFF') {
		mySType = mySType.push('TIF');
	}
	
	var myRType = new Array(ArrayTypesOfImages[dropReplace.selectedIndex]);
	if (myRType[0] == 'JPEG') {
		myRType = myRType.push('JPG');
	}
	if (myRType[0] == 'TIFF') {
		myRType = myRType.push('TIF');
	}

	var myWDIR = Folder.selectDialog(strSelectFld, wDir);
	if(myWDIR != null){ 
		wDir = myWDIR; 
 	} else {
 		exit();
 	}
	
	var myLinksArr = new Array();
	for (i = 0; i < myDoc.links.length; i++)
	{
		myLinksArr[i] = myDoc.links[i].name;
	}
	
	for (j = 0; j < myLinksArr.length; j++) {
		for (i = 0; i < myDoc.links.length; i++) {
			if(myLinksArr[j] == myDoc.links[i].name) {
				var myLink = myDoc.links[i];
				ss = myLink.name.split(".");
				myFileNameExt = ss[ss.length - 1];
				myFileName = myLink.name.substr(0, myLink.name.length - myFileNameExt.length);
				for (a = 0; a < mySType.length; a++) {
					if (myFileNameExt.toLowerCase() == mySType[a].toLowerCase()) {
						for (b = 0; b < myRType.length; b++) {
							myNewLinkName = wDir + "/" + myFileName + myRType[b].toLowerCase();
							var myFileNow = File(myNewLinkName);
								if (myFileNow.exists == true) {
									myLink.relink(myFileNow.fsName);
									myLink.update();
									var myFrame = myLink.parent.parent;		
									if (rb1.checkedState == true) { myFrame.fit(FitOptions.contentToFrame); }
									if (rb2.checkedState == true) { myFrame.fit(FitOptions.frameToContent); }
									if (rb3.checkedState == true) { myFrame.fit(FitOptions.proportionally); }
									if (rb4.checkedState == true) { myFrame.fit(FitOptions.centerContent); }
									if (rb0.checkedState == true) { var CarValueFit = 0; }
									if (rb1.checkedState == true) { var CarValueFit = 1; }
									if (rb2.checkedState == true) { var CarValueFit = 2; }
									if (rb3.checkedState == true) { var CarValueFit = 3; }
									if (rb4.checkedState == true) { var CarValueFit = 4; }
									Itsok = true;
								} else {
									if (chkAlert.checkedState == true) {
										alert(strFile + myNewLinkName + " " + strNoPresent);
									}
								}
						}
					}			
				}
			}
		}
	}
	SaveINI(dropSearch.selectedIndex, dropReplace.selectedIndex, CarValueFit, wDir, chkAlert.checkedState);
	exit();
}

function CreateINI() {	
	var myNewINIfile = new File (app.activeScript.path + "/InChange.ini");
	myNewINIfile.open("w");
	var myINI = "var iniScriptName = \"InChange\";\n";
	myINI = myINI + "var iniScriptVersion = \"1.0\";\n";
	myINI = myINI + "var iniLangFile = \"InChange.ru.slang\";\n";
	myINI = myINI + "var TOS = 0;\n";
	myINI = myINI + "var TOR = 0;\n";
	myINI = myINI + "var ValueFit = 0;\n";
	myINI = myINI + "var wDir = \"c\";\n";
	myINI = myINI + "var InfoLost = true;\n";
	myNewINIfile.write(myINI);
	myNewINIfile.close();	
	myINI = undefined;
	return CreateINI;
}

function SaveINI(TOSvalue, TORvalue, CurValueFit, wDirvalue, InfoLostvalue) {	
	var mySaveINIfile = new File (app.activeScript.path + "/InChange.ini");
	mySaveINIfile.open("w");
	var myINI = "var iniScriptName = \"InChange\";\n";
	myINI = myINI + "var iniScriptVersion = \"1.0\";\n";
	myINI = myINI + "var iniLangFile = \"" + iniLangFile + "\";\n";
	myINI = myINI + "var TOS = " + TOSvalue + ";\n";
	myINI = myINI + "var TOR = " + TORvalue + ";\n";
	myINI = myINI + "var ValueFit = " + CurValueFit +";\n";
	myINI = myINI + "var wDir = \"" + wDirvalue + "\";\n";
	myINI = myINI + "var InfoLost = " + InfoLostvalue + ";\n";
	mySaveINIfile.write(myINI);
	mySaveINIfile.close();
	myINI = undefined;
	return SaveINI;
}